<?php
/**
 *
 * Auteurs : Richard DEMONGEOT, Alan GARCIA (Durant le projet de PHP de notre anne scolaire
 *                                           2004-2005)
 *
 * Date : 10/02/2005
 *
 * Derniere modification : 09/12/2006
 *
 * Synopsys : Classe visant a rendre des fonctions de bases de donnes
 * 				generiques, avec comme contrainte de specifier quelques 
 *				parametres dans initialize.php
 *
**/

/*
Ce fichier est sous licence GPL V2.
Je vous demanderai toutefois de bien vouloir me faire parvenir (par mail ou par
un autre moyen  votre convenance) les modifications que vous tes suceptibles
d'y ajouter, ainsi que leurs justification.

--------------------------------------------------------------------------------------

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License.

Thanks to send me any change you can wrote to this project and their reasons.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

//Nous aurions voulu coder un switch, mais par 
//manque de temps nous n'avons pas pu.

require_once("./initialize.php"); /* Fichier d'initialisation */

/* le constructeur fait office de connexion */

/* Cette fonction permet de crer la base de donne voulue */
function Execute_cr_db ($_DB)
/* Ne fonctionne actuellement qu'avec MySQL */
{
	if (TYPE == ORACLE)
	 {
		$connexion=oci_connect(LOGIN, PASSWORD);
		$query="CREATE DATABASE $_DB";
		$resultat=oci_parse_error($query);
		oci_execute($resultat);
	}
	else if (TYPE == POSTGRE)
	{
		$connexion=$pg_connect("host=".HOTE." port=".PORT." user=".LOGIN." password=".PASSWORD);
		$query="CREATE DATABASE $_DB";
		pg_query($connexion, $query);
	}
	else if (TYPE == MYSQL)
	{
		$connexion=mysql_connect(HOTE, LOGIN, PASSWORD);
		$query="CREATE DATABASE $_DB";
		mysql_query($query);
	}
}
	
class cbd
{

	var $ORACLE;        /* booleen pour bd oracle */
	var $POSGRESQL;     /* booleen pour bd posgree sql */
	var $MYSQL;         /* booleen pour bd mysql */

	var $connexion;     /* variable de connexion */
	var $CaseSensitive; /* si le sgbd necessite une casse speciale.
	                       1 => Casse spciale et 0 casse de cration des tables*/
	var $majuscule;     /* si le sgbd fonctionne en majuscule ou minuscule.
	                       1 => MAJUSCULE et 0 => minuscule 
			       Cette vatiable est INUTILE donc choisie arbitrairement
			       dans le cas ou CaseSensitive est a 0 */

	function cbd ()/* fait office de connexion */
	{
		if (TYPE == ORACLE)
		{
			$this->ORACLE=1;
			$this->POSGRESQL=0;
			$this->MYSQL=0;
			$this->connexion=oci_connect(LOGIN, PASSWORD, DATABASE);
			$this->CaseSensitive=1;
			$this->majuscule=1;
		}
		else if (TYPE == POSTGRE)
		{
			$this->ORACLE=0;
			$this->POSGRESQL=1;
			$this->MYSQL=0;
			$this->connexion=pg_connect
			     ("host=".HOTE." port=".PORT." dbname=".DATABASE." user=
				         ".LOGIN." password=".PASSWORD);
			$this->CaseSensitive=1;
			$this->majuscule=0;
		}
		else if (TYPE == MYSQL)
		{
			$this->ORACLE=0;
			$this->POSGRESQL=0;
			$this->MYSQL=1;
			$this->connexion=mysql_connect(HOTE, LOGIN, PASSWORD);
			mysql_select_db(DATABASE, $this->connexion);
			$this->CaseSensitive=0;
			$this->majuscule=1; /* inutile et arbitraire */
		}

	}//CBD
	/* 
	Utilisation :
	require_once("./cbd.php"); // Insertion de ce code
	$connexion=cbd();          // Creation de la variable de connexion et de l'objet d'interfacage
	*/

	/*
	2 fonctions peu utiles mais gardes par soucis de rtro
	compatibilit

	Aujourd'hui remplaces avantgeusement par NomChamp

	Get_CSens => indique si la base de donne impose une casse ou non
	1 => Il faut une casse spciale
	0 => Casse de cration des tables
	
	Get_maj => Indique si la base de donne utilise est en majuscule
	ou en minuscule (1 => majuscule, 0 => minuscule)

	Historiquement utilis dans les Fetch_row ou Fetch_assoc
	pour avoir la bonne casse sur le nom du champ.
	*/
	
	/* Utilisation : $connexion->fonction (); */
	function Get_CSens () {return $this->CaseSensitive;}
	function Get_maj () {return $this->majuscule;}

	/* Fonction qui execute la requete SQL passe */
	/*
	Utilisation : 
	$connexion->Execute ($MaRequete);
	OU
	$connexion->Execute ("requete SQL");
	*/
	function Execute ($_req)
	{
		if ($this->CaseSensitive)
		$_req = $this->majuscule?strtoupper($_req):strtolower($_req);
		if ($this->ORACLE)
		{
			$resultat=oci_parse($this->connexion, $_req);
			oci_execute($resultat);
		}
		else if ($this->MYSQL)
			$resultat=mysql_query($_req);
		else if ($this->POSGRESQL)
			$resultat=pg_query($this->connexion, $_req);
		
		return $resultat;
	}

	/* Fonction qui parse les rsultats fetch_row */
	function Fetch_row ($_resultat)
	{
		if ($this->ORACLE)
			return oci_fetch_row($_resultat);
		else if ($this->MYSQL)
			return mysql_fetch_row($_resultat);
		else if ($this->POSGRESQL)
			return pg_fetch_row ($_resultat);
					/*second param optionnel depuis php4.10*/
	}
	/* Fonction qui parse les rsultats fetch_assoc */
	function Fetch_assoc ($_resultat)
	{
		if ($this->ORACLE)
			return oci_fetch_assoc($_resultat);
		else if ($this->MYSQL)
			return mysql_fetch_assoc($_resultat);
		else if ($this->POSGRESQL)
			return pg_fetch_assoc($_resultat);
	}
	/*
	fin des fonctions necessaires pour le projet de PHP
	*/
	/* Fonction qui remplace Get_CSens et Get_maj */
        function NomChamp ($_Nom)
        {
		if ($this->CaseSensitive)
			return $this->majuscule?strtoupper($_Nom):strtolower($_Nom);
		else return $_Nom;
	}

};//class cbd
?>
